﻿Imports System.Net
Imports YouTubeInfo

Public Class FrmMain
#Region "Declarations"
    Private _YouTubeVideo As YouTubeVideo
    Private Lst As New List(Of Uri)
    Private DownloadUrl As Uri
    Private WithEvents wC As New WebClient
#End Region

#Region "GetVideoInfo"
    Private Sub GetVideoInfo()
        Me.BeginInvoke(Sub()
                           lblInfo.Text = "Video wird analysiert... Bitte warten."
                           pbProgress.Style = ProgressBarStyle.Marquee
                       End Sub)
        Me.BeginInvoke(Sub()
                           btnadd.Enabled = False
                           lblInfo.Text = "Name: " & _YouTubeVideo.Name & Environment.NewLine & _
                               "ID: " & _YouTubeVideo.ID & Environment.NewLine & _
                               "Views: " & _YouTubeVideo.Views & Environment.NewLine & _
                               "Likes: " & _YouTubeVideo.Likes & Environment.NewLine & _
                               "Dislikes: " & _YouTubeVideo.Dislikes & Environment.NewLine & _
                               "Länge: " & _YouTubeVideo.Length.ToString()
                           picCover.Image = _YouTubeVideo.Cover
                           btnadd.Enabled = True
                           pbProgress.Style = ProgressBarStyle.Blocks
                       End Sub)
    End Sub
#End Region

#Region "Buttons"
    Private Sub btnDownload_Click(sender As Object, e As EventArgs) Handles btnDownload.Click
        If FBD.ShowDialog() = Windows.Forms.DialogResult.OK Then
            txtUrl.Enabled = False
            CQuality.Enabled = False
            btnadd.Enabled = False
            btnDownload.Enabled = False
            wC.DownloadFileAsync(Lst.Item((CQuality.SelectedIndex)), FBD.SelectedPath & "\" & _YouTubeVideo.Name & "." & CQuality.Items.Item(CQuality.SelectedIndex).ToString().Remove(CQuality.Items.Item(CQuality.SelectedIndex).ToString().IndexOf("(")))
        End If
    End Sub

    Private Sub btnadd_Click(sender As Object, e As EventArgs) Handles btnadd.Click
        Dim _Thread As New Threading.Thread(AddressOf GetVideoInfo)
        _Thread.Start()
        pbProgress.Value = 0
        Me.Text = "YouTubeInfo Test - Application"
        _YouTubeVideo = New YouTubeVideo(New Uri(txtUrl.Text))
        Lst.Clear()
        CQuality.Items.Clear()
        For Each h As Video In _YouTubeVideo.DownloadUrls
            CQuality.Items.Add(h.VideoQuality.VideoExtension.ToString & "( " & h.VideoQuality.Quality.ToString.Replace("q", "") & "p )")
            Lst.Add(New Uri(h.DownloadLink))
        Next
    End Sub
#End Region

#Region "Webclient"
    Private Sub wC_DownloadFileCompleted(sender As Object, e As System.ComponentModel.AsyncCompletedEventArgs) Handles wC.DownloadFileCompleted
        MessageBox.Show("Download abgeschlossen", "Fertig !", MessageBoxButtons.OK, MessageBoxIcon.Information)
        txtUrl.Enabled = True
        CQuality.Enabled = True
        btnadd.Enabled = True
        btnDownload.Enabled = True
    End Sub

    Private Sub wC_DownloadProgressChanged(sender As Object, e As DownloadProgressChangedEventArgs) Handles wC.DownloadProgressChanged
        pbProgress.Value = e.ProgressPercentage
        Me.Text = String.Format("YouTubeInfo Test - Application - Downloading: {0} % ", e.ProgressPercentage)
    End Sub
#End Region
End Class
